/*
 *  Source generated with GadToolsBox V1.3
 *  which is (c) Copyright 1991,92 Jaba Development
 */

#define MIN(a,b)    ((a)<(b)?(a):(b))
#define MAX(a,b)    ((a)>(b)?(a):(b))

#include "pchelp.h"
#include "psdata.h"

extern GLOBAL_DATA PROSET;

struct Screen        *Scr = NULL;
struct TextAttr      *TAttr;
APTR                  VisualInfo = NULL;
struct Window        *PopCliIVWnd = NULL;
struct Gadget        *PopCliIVGList = NULL;
struct Gadget        *PopCliIVGadgets[6];
UWORD                 PopCliIVLeft;
UWORD                 PopCliIVTop;
UWORD                 PopCliIVWidth;
UWORD                 PopCliIVHeight;
UBYTE                *PopCliIVWdt = (UBYTE *)"PopCliIV";
UWORD                 BevelBoxHeight;
UWORD                 StringGadWidth;

int SetUpScreen( void )
{
   if ( ! ( Scr = LockPubScreen( NULL )))
      return( 1L );

   if ( ! ( VisualInfo = GetVisualInfo( Scr, TAG_DONE )))
      return( 2L );

   ScreenToFront( Scr   );
   TAttr                         =  Scr->Font;

   return( 0L );
}

void CloseDownScreen( void )
{
   if ( VisualInfo ) {
      FreeVisualInfo( VisualInfo );
      VisualInfo = NULL;
   }

   if ( Scr        ) {
      UnlockPubScreen( NULL, Scr );
      Scr = NULL;
   }
}

void PopCliHelpSize( void )
{
   UWORD offx, offy,
         rightWidth;
   WORD  alen,
         blen,
         clen,
         dlen;

   offx = Scr->WBorLeft;
   offy = Scr->WBorTop + Scr->RastPort.TxHeight + 1;

   StringGadWidth    =  6 +
                        TextLength( &(Scr->RastPort),
                                    "rawkey lcommand alt help",
                                    strlen("rawkey lcommand alt help") ) +
                        6;

   alen = 4 + StringGadWidth +
          TextLength( &(Scr->RastPort), "PopCli ShortCut", strlen("PopCli ShortCut") ) +
          TAttr->ta_YSize + 4;
   blen = 4 + StringGadWidth +
          TextLength( &(Scr->RastPort), "PopCli Command", strlen("PopCli Command") ) +
          TAttr->ta_YSize + 4;
   clen = 4 + StringGadWidth +
          TextLength( &(Scr->RastPort), "For this help", strlen("For this help") ) +
          TAttr->ta_YSize + 4;
   dlen = 4 + StringGadWidth +
          TextLength( &(Scr->RastPort), "Look for a Shell", strlen("Look for a Shell") ) +
          TAttr->ta_YSize + 4;


   rightWidth     =  MAX( MAX(alen,blen), clen );


   PopCliIVWidth  =  Scr->WBorLeft + rightWidth + Scr->WBorRight;

   PopCliIVLeft   =  Scr->MouseX - PopCliIVWidth/2;
   PopCliIVTop    =  Scr->MouseY - offy/2;
}


void PopCliIVRender( void )
{
    UWORD        offx, offy;

    offx = PopCliIVWnd->BorderLeft;
    offy = PopCliIVWnd->BorderTop;

    DrawBevelBox( PopCliIVWnd->RPort, offx + 0, offy + 0,
                  PopCliIVWidth - (PopCliIVWnd->BorderRight) - offx,
                  BevelBoxHeight,
                  GT_VisualInfo, VisualInfo,
                  TAG_DONE );
}

int OpenPopCliIVWindow( void )
{
   struct NewGadget    ng;
   struct Gadget       *g;
   UWORD               offx, offy;

   PopCliHelpSize();

   offx = Scr->WBorLeft;
   offy = Scr->WBorTop + Scr->RastPort.TxHeight + 1;

   if ( ! ( g = CreateContext( &PopCliIVGList )))
      return( 1L );

   ng.ng_LeftEdge       =     offx + 4;
   ng.ng_TopEdge        =     offy + 2;
   ng.ng_Width          =     StringGadWidth;
   ng.ng_Height         =     TAttr->ta_YSize + 5;
   ng.ng_GadgetText     =     (UBYTE *)"PopCli ShortCut";
   ng.ng_TextAttr       =     TAttr;
   ng.ng_GadgetID       =     GD_popcli_sc;
   ng.ng_Flags          =     PLACETEXT_RIGHT;
   ng.ng_VisualInfo     =     VisualInfo;

   g = CreateGadget( STRING_KIND, g, &ng, GTST_String, PROSET.popcli, GTST_MaxChars, 256, TAG_DONE );

   PopCliIVGadgets[ 0 ] = g;

   ng.ng_TopEdge        =     ng.ng_TopEdge + ng.ng_Height + 1;
   ng.ng_GadgetText     =     (UBYTE *)"PopCli Command";
   ng.ng_GadgetID       =     GD_popcli_cmd;

   g = CreateGadget( STRING_KIND, g, &ng, GTST_String, PROSET.popclicmd, GTST_MaxChars, 256, TAG_DONE );

   PopCliIVGadgets[ 1 ] = g;

   BevelBoxHeight       =     ng.ng_TopEdge + ng.ng_Height + 2 - offy;
   ng.ng_TopEdge        =     ng.ng_TopEdge + ng.ng_Height + 4;
   ng.ng_GadgetText     =     (UBYTE *)"For this help";
   ng.ng_GadgetID       =     GD_help_sc;

   g = CreateGadget( STRING_KIND, g, &ng, GTST_String, PROSET.helpme, GTST_MaxChars, 256, TAG_DONE );

   PopCliIVGadgets[ 2 ] = g;

   ng.ng_TopEdge        =     ng.ng_TopEdge + ng.ng_Height + 1;
   ng.ng_GadgetText     =     (UBYTE *)"Look for a Shell";
   ng.ng_GadgetID       =     GD_lookfor_sc;

   g = CreateGadget( STRING_KIND, g, &ng, GTST_String, PROSET.lookfor, GTST_MaxChars, 256, TAG_DONE );

   PopCliIVGadgets[ 5 ] = g;

   ng.ng_LeftEdge       =     offx + (PopCliIVWidth-Scr->WBorLeft-Scr->WBorRight)/2 + 1;
   ng.ng_TopEdge        =     ng.ng_TopEdge + ng.ng_Height + 2;
   ng.ng_Width          =     (PopCliIVWidth-Scr->WBorLeft-Scr->WBorRight)/2 - 2;
   ng.ng_Height         =     2*(TAttr->ta_YSize + 5);
   ng.ng_GadgetText     =     (UBYTE *)"remove";
   ng.ng_GadgetID       =     GD_quit;
   ng.ng_Flags          =     PLACETEXT_IN;

   g = CreateGadget( BUTTON_KIND, g, &ng, TAG_DONE );

   PopCliIVGadgets[ 3 ] = g;

   ng.ng_LeftEdge       =     offx + 1;
   ng.ng_GadgetText     =     (UBYTE *)"hide";
   ng.ng_GadgetID       =     GD_hide;

   g = CreateGadget( BUTTON_KIND, g, &ng, TAG_DONE );

   PopCliIVGadgets[ 4 ] = g;

   if ( ! g )
      return( 2L );

   PopCliIVHeight       =     ng.ng_TopEdge + ng.ng_Height + Scr->WBorBottom;

   PopCliHelpSize();

   if ( ! ( PopCliIVWnd = OpenWindowTags( NULL,
                  WA_Left,          PopCliIVLeft,
                  WA_Top,           PopCliIVTop,
                  WA_Width,         PopCliIVWidth,
                  WA_Height,        PopCliIVHeight,
                  WA_IDCMP,         STRINGIDCMP|BUTTONIDCMP|IDCMP_CLOSEWINDOW|IDCMP_REFRESHWINDOW,
                  WA_Flags,         WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_CLOSEGADGET|WFLG_SMART_REFRESH,
                  WA_Gadgets,       PopCliIVGList,
                  WA_Title,         PopCliIVWdt,
                  WA_ScreenTitle,   "GadToolsBox v1.3  1991,92 ",
                  WA_PubScreen,     Scr,
                  TAG_DONE )))
      return( 4L );

   GT_RefreshWindow( PopCliIVWnd, NULL );

   PopCliIVRender();

   return( 0L );
}

void ClosePopCliIVWindow( void )
{
   struct IntuiMessage  *imsg;

   if ( PopCliIVWnd        ) {
      while( (imsg = GT_GetIMsg(PopCliIVWnd->UserPort)) )
         GT_ReplyIMsg(imsg);
      CloseWindow( PopCliIVWnd );
      PopCliIVWnd = NULL;
   }

   if ( PopCliIVGList      ) {
      FreeGadgets( PopCliIVGList );
      PopCliIVGList = NULL;
   }
}

